
/*
 * Example of the use of open_scan() function.
 */

#include <iostream.h>

int main(int argc, char **argv)
{
    cout << "scan4.S: Demonstrating open_scan().\n";

    init_coral(argv[0]);
  
    \[
      clear(interactive_mode).
    \]

    // Enter some sample data (with sets)
    \[
      myset(0, {0,1,2}).
      myset(5, {one,two,three}).
      myset(0, {4,5,6}).
      myset(4, {3.14,foo,8}).
      myset(9, {1,2,0}).
      myset(2, {name, 2.0, 2}).
    \]

      // Scan the whole relation
    Cor_ScanDesc *scan = open_scan("myset(_,_).");

    ASSERT(scan);

    Cor_Tuple *tuple;

      // Iterate over the tuples in the relation
    for (tuple = scan->next_tuple(); !(scan->no_match());
                     tuple = scan->next_tuple()) {

          // Print them out as tuples 
        cout << "myset(" << *tuple << ").\n";
    }

    exit_coral();

    return(0);
}

