// *************************************************************************
//    RelationStruct.h
// *************************************************************************

#ifndef _RelationStruct_H_
#define _RelationStruct_H_

#include "CArg.h"

// *************************************************************************

class Cor_Relation;

// *************************************************************************
// Contains a relation pointer and the name of the relation

class Cor_RelationStruct {

  public:
    Cor_Relation *relPtr;
    Cor_CArg      relName;
    int           relArity;

    Cor_RelationStruct() {
        relPtr = NULL;
        relArity = 0;
    }

   ~Cor_RelationStruct();

    void AssignVal(Cor_CArg& name, int arity);
    void AssignRel(Cor_Relation *rel) {
        relPtr = rel;
    }

    void ClearRel() {
        relPtr = NULL;
        relArity = 0;
    }
};

// *************************************************************************

#endif _RelationStruct_H_
